var ybu_swfu;

function ybu_cancel(fileid)
{
	//cancel upload
	ybu_swfu.cancelUpload(fileid, false);

	//remove element from list
	var progressElem = document.getElementById("ybu_progress_list");
	var li = document.getElementById("ybu_upload_"+fileid);
	progressElem.removeChild(li);
}

function ybu_fileDialogComplete(num_files_queued) 
{
	ybu_swfu.startUpload();
}

function ybu_fileQueued(file)
{

	//show progress list
	var progressDiv = document.getElementById("ybu_progress");
	progressDiv.style.visibility = "visible";
	
	//get progress list en done element
	var progressElem = document.getElementById("ybu_progress_list");
	var doneDiv = document.getElementById("ybu_done");

	//check if previous upload is finished 
	if(doneDiv.style.visibility == "visible")
	{
		//hide done div
		doneDiv.style.visibility = "hidden";
		
		//clear old files from list
		progressElem.innerHTML = ""; 
	}

	//Add file to progress list	
	var liElem = document.createElement("LI");
	liElem.id = "ybu_file_"+file.id;
	liElem.className = "ybu_file";
	
	var pElem = document.createElement("P");
	var textElem = document.createTextNode(file.name + " (pending)");
	pElem.appendChild(textElem);
	liElem.appendChild(pElem);
	
	var divElem = document.createElement("DIV");
	divElem.id = "ybu_file_progress_"+file.id;
	divElem.className = "ybu_file_progress";
	liElem.appendChild(divElem);

	progressElem.appendChild(liElem);
}

function ybu_fileQueueError(file, error_code, message) 
{
	var msg;
	switch (error_code) 
	{
		case SWFUpload.QUEUE_ERROR.QUEUE_LIMIT_EXCEEDED:
			msg = "Too many file are queued for upload. You may upload up to " + message + "files.";
			break;
		case SWFUpload.QUEUE_ERROR.FILE_EXCEEDS_SIZE_LIMIT:
			msg = "The file "+ file.name + " is too big. You may upload files up to "+  ybu_swfu.settings.file_size_limit;
			break;
		case SWFUpload.QUEUE_ERROR.ZERO_BYTE_FILE:
			msg = "The file " + file.name + " is zero bytes. Files must be a bit bigger...";
			break;
		case SWFUpload.QUEUE_ERROR.INVALID_FILETYPE:
			msg = "The file " + file.name + " is of an incorrect type. Accepted types are " + ybu_swfu.settings.file_types;
			break;
		default:
			msg = "Unknown file queue error ("+error_code+")for "+file.name + ": " + message;
			break;
	}
	
	window.status = msg;
	window.alert(msg);
}


function ybu_uploadStart(file)
{
	//alert("starting: "+file.name);

	//get form values
	var exifdate = document.getElementById("ybu_exifdate").checked ? 1 : 0;
	var iptc = document.getElementById("ybu_iptc").checked ? 1 : 0;
	var category = document.getElementById("ybu_category").value;
	var author = document.getElementById("ybu_user").value;

	//add post params
	ybu_swfu.addFileParam(file.id, "post_title", file.name.replace("_"," "));
	ybu_swfu.addFileParam(file.id, "exifdate", exifdate);
	ybu_swfu.addFileParam(file.id, "post_author", author);
	ybu_swfu.addFileParam(file.id, "post_category[]", category);
	ybu_swfu.addFileParam(file.id, "ybu_iptc", iptc);
	//ybu_swfu.addFileParam(file.id, "filesize", file.size);

	return true;
}

function ybu_uploadProgress(file, complete, total)
{
	var done = Math.round(complete / total * 100);
	
	var msg = "";
	if(done>=100)
		msg = "<p>"+file.name + " (crunching...)</p>";
	else
		msg = "<p>"+file.name + " ("+done+"%, <a href='javascript:ybu_cancel("+file.id+")'>cancel</a>)</p>";

	var progressDiv = document.getElementById("ybu_file_progress_"+file.id);
	progressDiv.style.width = "" + done +"%";
	progressDiv.innerHTML = msg;

	var progressLi = document.getElementById("ybu_file_"+file.id);
	var progressP = progressLi.getElementsByTagName("P")[0];
	progressP.innerHTML = msg;
}

function ybu_uploadSuccess(file, serverData)
{
	//clear string in file element
	var progressLi = document.getElementById("ybu_file_"+file.id);
	var progressP = progressLi.getElementsByTagName("P")[0];
	var progressDiv = document.getElementById("ybu_file_progress_"+file.id);
	progressDiv.style.width = "100%";

	//set correct text and style in progress overlay 
	var msg = " ";
	if(serverData.substr(0,4)=="Err:")
	{
		//error
		progressDiv.className = "ybu_error";
		msg = file.name + " ("+serverData.substring(5)+")";
	}
	else
	{
		//success
		progressDiv.className = "ybu_done";
		msg = file.name + " ("+serverData+")";
	}
	
	//display message
	progressDiv.innerHTML = "<p>"+msg+"</p>";
	progressP.innerHTML = msg;

}

function ybu_uploadError(file, error_code, message)
{
	//alert("Error: "+message);
	var msg;
	switch (error_code) {
		case SWFUpload.UPLOAD_ERROR.HTTP_ERROR:
			if(message==403)
				msg = "Authentication Error";
			else
				msg = "HTTP Error "+message;
			
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_FAILED:
			msg = "Upload failed: "+message;
			break;
		case SWFUpload.UPLOAD_ERROR.IO_ERROR:
			msg = "IO Error: "+message;
			break;
		case SWFUpload.UPLOAD_ERROR.SECURITY_ERROR:
			msg = "Security Error: "+message;
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_LIMIT_EXCEEDED:
			msg = "Upload Size Limit Exceeded: "+message;
			break;
		case SWFUpload.UPLOAD_ERROR.FILE_VALIDATION_FAILED:
			msg = "Failed Validation: "+message;
			break;
		case SWFUpload.UPLOAD_ERROR.FILE_CANCELLED:
			msg = "Upload Cancelled";
			break;                 
		case SWFUpload.UPLOAD_ERROR.UPLOAD_STOPPED:
			msg = "Upload Stopped";
			break;
		default:
			msg = "Unknown Error("+error_code + "): " + message;
			break;
	} 

	//clear string in file element
	var progressLi = document.getElementById("ybu_file_"+file.id);
	var progressP = progressLi.getElementsByTagName("P")[0];
	progressP.innerHTML = file.name + " ("+msg+")";

	//show error in progress overlay
	var progressDiv = document.getElementById("ybu_file_progress_"+file.id);
	progressDiv.className = "ybu_error";
	progressDiv.style.width = "100%";
	progressDiv.innerHTML = "<p>"+file.name + " ("+msg+")</p>";
}

function ybu_uploadComplete(file)
{
	
	var stats = ybu_swfu.getStats();
	//alert(stats.files_queued);
	
	if(stats.files_queued > 0)
	{
		//next upload
		ybu_swfu.startUpload();
	}
	else
	{
		//show done
		var doneDiv = document.getElementById("ybu_done");
		doneDiv.style.visibility = "visible";
	}
}
